
from launchpadlib.launchpad import Launchpad
import Image
import ImageDraw2
import ImageFont
import random
import StringIO

#get all the devs
cachedir = "lp_cache"
lp = Launchpad.login_anonymously('ubuntu_dev_pics', 'production', cachedir)
devs = filter(lambda a: not a.is_team, lp.people['ubuntu-dev'].participants)

d = devs[ random.randint(1,len(devs)) - 1]

background = Image.new("RGBA", (1920,1080), "#2C001E")
left_margin = 300
top_margin = 50
title_left = left_margin

mug_bottom = 0
try:
    mug_data = d.mugshot.open()
    mug = Image.open(StringIO.StringIO(mug_data.read()))
    background.paste(mug,(left_margin,top_margin))
    title_left += mug.size[0] * .75
    mug_bottom = mug.size[1] 
except Exception, inst:
    pass

font = ImageFont.truetype("/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-C.ttf",72)
font.color = "black"
draw = ImageDraw2.Draw(background)
draw.text((title_left + 5 ,top_margin + 5),d.display_name,font)

font.color = "#DD4814"
draw = ImageDraw2.Draw(background)
draw.text((title_left, top_margin),d.display_name,font)


irc_nicks = []
for n in d.irc_nicknames:
    if n.nickname not in irc_nicks:
        irc_nicks.append(n.nickname)

nick_string = ""
for n in irc_nicks:
    nick_string += n + " "

if nick_string != "":
    nick_string = "on irc: " + nick_string

name_width, name_height = draw.textsize(d.display_name,font)[0]

font = ImageFont.truetype("/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-C.ttf",24)
font.color = "#DD4814"


name_bottom = top_margin + name_height
width, height = draw.textsize(nick_string, font)[0]

nick_top = ( top_margin + name_bottom - height ) / 2
nick_left = name_width + title_left + 3

draw.text((nick_left,nick_top),nick_string, font)

homepage_left = left_margin
homepage_right = background.size[0]

if mug_bottom != 0:
   homepage_top = top_margin + mug_bottom + 5
else:
    homepage_top = name_bottom + 5

font = ImageFont.truetype("/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-C.ttf",24)
font.color = "#DD4814"

word_left = homepage_left
word_top = homepage_top
homepage_bottom = homepage_top

if d.homepage_content is not None:
    homepage_words = d.homepage_content.split(" ")
    
    for word in homepage_words:
        word = word + " "
        width, height = draw.textsize(word, font=font)[0]
        if homepage_bottom == homepage_top:
            homepage_bottom += height
        if word_left + width > homepage_right:
            word_left = homepage_left
            word_top += height + 2
            homepage_bottom += height
        draw.text((word_left, word_top), word, font)
        word_left += width

logos = []
team_names = []
for m in d.memberships_details:
    try:
        team_names.append(m.team.display_name)
        logo_data = m.team.logo.open()
        logo = Image.open(StringIO.StringIO(logo_data.read()))
        logos.append(logo)
    except Exception:
        #almost always, there was no logo
        pass

team_top = homepage_bottom + 5
team_right = background.size[0]

font = ImageFont.truetype("/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-LI.ttf",36)
font.color = "#DD4814"
draw.text((left_margin,team_top),"Team Memberships",font)
team_top += draw.textsize("Team Memberships",font)[0][1]

logo_left = left_margin
for logo in logos:
    background.paste(logo,(logo_left,team_top))
    logo_left += 65
    if logo_left > team_right - 65:
        logo_left = left_margin
        team_top += 65

font = ImageFont.truetype("/usr/share/fonts/truetype/ubuntu-font-family/Ubuntu-C.ttf",24)
font.color = "#DD4814"
name_left = left_margin
name_top = team_top + 65
for i, team_name in enumerate(team_names):
    size = draw.textsize(team_name  + "  *  ", font=font)
    width = size[0][0]
    height = size[0][1]

    if name_left + width > team_right:
        name_left = left_margin
        name_top += height + 2
    #elif i != 0 and i < len(team_names)-1:
        #draw.text((name_left,name_top),"  *  ",font)
        #name_left += draw.textsize("  *  ", font=font)[0][1]
    draw.text((name_left,name_top),team_name,font)
    name_left += width

#add d.ppas.description, etc...
#add d.languages
#add latitude and longitude
#add date_created
#add karma

background.show()

